Auto-detect screen on ToggleFullScreen if used with Xinerama support.
This is based on the mouse pointer position.
config_GetInt( p_vout, MODULE_STRING "-altfullscreen" ) has to be set to -1

---
 modules/video_output/x11/xcommon.c |   33 +++++++++++++++++++++++++++++++--
 1 files changed, 31 insertions(+), 2 deletions(-)

diff --git a/modules/video_output/x11/xcommon.c b/modules/video_output/x11/xcommon.c
index c3c686f..6fccbb3 100644
--- a/modules/video_output/x11/xcommon.c
+++ b/modules/video_output/x11/xcommon.c
@@ -2213,12 +2213,41 @@ static void ToggleFullScreen ( vout_thread_t *p_vout )
                                             &i_num_screens );
 
             SCREEN = config_GetInt( p_vout,
-                                        MODULE_STRING "-xineramascreen" );
+                                    MODULE_STRING "-xineramascreen" );
+
+            /* Automagically guess current screen */
+            if( SCREEN < 0 )
+            {
+                /* Get mouse pointer position */
+                int i_x, i_y, i_winx, i_winy, i_mask;
+                Window w_root, w_child;
+                Bool b_res = XQueryPointer( p_vout->p_sys->p_display,
+                        p_vout->p_sys->p_win->base_window,
+                        &w_root, &w_child,
+                        &i_x, &i_y, &i_winx, &i_winy, &i_mask );
+
+                int i;
+                for( i = 0; i < i_num_screens; i++ )
+                {
+                    if( (i_x >= screens[i].x_org)
+                     && (i_x <= screens[i].x_org + screens[i].width )
+                     && (i_y >= screens[i].y_org)
+                     && (i_y <= screens[i].y_org + screens[i].height ) )
+                    {
+                        SCREEN = screens[i].screen_number;
+                        break;
+                    }
+                }
+
+                if( SCREEN >= 0 )
+                    msg_Dbg( p_vout, "guessed screen number %d\n", SCREEN );
+            }
 
             /* just check that user has entered a good value */
             if( SCREEN >= i_num_screens || SCREEN < 0 )
             {
-                msg_Dbg( p_vout, "requested screen number invalid (%d/%d)", SCREEN, i_num_screens );
+                msg_Dbg( p_vout, "requested screen number invalid (%d/%d)",
+                         SCREEN, i_num_screens );
                 SCREEN = 0;
             }
 
-- 
1.5.4.4

